]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: let the OS choose a port for smtp-dummy
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # Save STDOUT to fd 6 and STDERR to fd 7.
59 exec 6>&1 7>&2
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
61 BASH_XTRACEFD=7
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
63
64 # Keep the original TERM for say_color and test_emacs
65 ORIGINAL_TERM=$TERM
66
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
70 case ${TERM-} in
71         '' | dumb | unknown )
72                 SMART_TERM=vt100 ;;
73         *)
74                 SMART_TERM=$TERM ;;
75 esac
76
77 # For repeatability, reset the environment to known value.
78 LANG=C
79 LC_ALL=C
80 PAGER=cat
81 TZ=UTC
82 TERM=dumb
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
88     exit 1
89 fi
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 # For emacsclient
103 unset ALTERNATE_EDITOR
104
105 add_gnupg_home ()
106 {
107     local output
108     [ -d ${GNUPGHOME} ] && return
109     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110     at_exit_function _gnupg_exit
111     mkdir -m 0700 "$GNUPGHOME"
112     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113     test_debug "cat $GNUPGHOME/import.log"
114     if (gpg --quick-random --version >/dev/null 2>&1) ; then
115         echo quick-random >> "$GNUPGHOME"/gpg.conf
116     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
118     fi
119     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
120
121     # Change this if we ship a new test key
122     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
123     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
124     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
125 }
126
127 # Each test should start with something like this, after copyright notices:
128 #
129 # test_description='Description of this test...
130 # This test checks if command xyzzy does the right thing...
131 # '
132 # . ./test-lib.sh || exit 1
133
134 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
135                 TERM=$ORIGINAL_TERM &&
136                 export TERM &&
137                 [ -t 1 ] &&
138                 tput bold >/dev/null 2>&1 &&
139                 tput setaf 1 >/dev/null 2>&1 &&
140                 tput sgr0 >/dev/null 2>&1
141         ) &&
142         color=t
143
144 while test "$#" -ne 0
145 do
146         case "$1" in
147         -d|--debug)
148                 debug=t; shift ;;
149         -i|--immediate)
150                 immediate=t; shift ;;
151         -h|--help)
152                 help=t; shift ;;
153         -v|--verbose)
154                 verbose=t; shift ;;
155         -q|--quiet)
156                 quiet=t; shift ;;
157         --with-dashes)
158                 with_dashes=t; shift ;;
159         --no-color)
160                 color=; shift ;;
161         --no-python)
162                 # noop now...
163                 shift ;;
164         --valgrind)
165                 valgrind=t; verbose=t; shift ;;
166         --tee)
167                 shift ;; # was handled already
168         *)
169                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
170         esac
171 done
172
173 if test -n "$debug"; then
174     print_subtest () {
175         printf " %-4s" "[$((test_count - 1))]"
176     }
177 else
178     print_subtest () {
179         true
180     }
181 fi
182
183 if test -n "$color"; then
184         say_color () {
185                 (
186                 TERM=$ORIGINAL_TERM
187                 export TERM
188                 case "$1" in
189                         error) tput bold; tput setaf 1;; # bold red
190                         skip)  tput bold; tput setaf 2;; # bold green
191                         pass)  tput setaf 2;;            # green
192                         info)  tput setaf 3;;            # brown
193                         *) test -n "$quiet" && return;;
194                 esac
195                 shift
196                 printf " "
197                 printf "$@"
198                 tput sgr0
199                 print_subtest
200                 )
201         }
202 else
203         say_color() {
204                 test -z "$1" && test -n "$quiet" && return
205                 shift
206                 printf " "
207                 printf "$@"
208                 print_subtest
209         }
210 fi
211
212 error () {
213         say_color error "error: $*\n"
214         GIT_EXIT_OK=t
215         exit 1
216 }
217
218 say () {
219         say_color info "$*"
220 }
221
222 test "${test_description}" != "" ||
223 error "Test script did not set test_description."
224
225 if test "$help" = "t"
226 then
227         echo "Tests ${test_description}"
228         exit 0
229 fi
230
231 test_description_printed=
232 print_test_description ()
233 {
234         test -z "$test_description_printed" || return 0
235         echo
236         echo $this_test: "Testing ${test_description}"
237         test_description_printed=1
238 }
239 if [ -z "$NOTMUCH_TEST_QUIET" ]
240 then
241         print_test_description
242 fi
243
244 test_failure=0
245 test_count=0
246 test_fixed=0
247 test_broken=0
248 test_success=0
249
250 declare -a _exit_functions=()
251
252 at_exit_function () {
253         _exit_functions=($1 ${_exit_functions[@]/$1})
254 }
255
256 rm_exit_function () {
257         _exit_functions=(${_exit_functions[@]/$1})
258 }
259
260 _exit_common () {
261         code=$?
262         trap - EXIT
263         set +ex
264         for _fn in ${_exit_functions[@]}; do $_fn; done
265         rm -rf "$TEST_TMPDIR"
266 }
267
268 trap_exit () {
269         _exit_common
270         if test -n "$GIT_EXIT_OK"
271         then
272                 exit $code
273         else
274                 exec >&6
275                 say_color error '%-6s' FATAL
276                 echo " $test_subtest_name"
277                 echo
278                 echo "Unexpected exit while executing $0. Exit code $code."
279                 exit 1
280         fi
281 }
282
283 trap_signal () {
284         _exit_common
285         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
286         exit $code
287 }
288
289 die () {
290         _exit_common
291         exec >&6
292         say_color error '%-6s' FATAL
293         echo " $*"
294         echo
295         echo "Unexpected exit while executing $0."
296         exit 1
297 }
298
299 GIT_EXIT_OK=
300 # Note: TEST_TMPDIR *NOT* exported!
301 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
302 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
303 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
304 trap 'trap_exit' EXIT
305 trap 'trap_signal' HUP INT TERM
306
307 # Deliver a message with emacs and add it to the database
308 #
309 # Uses emacs to generate and deliver a message to the mail store.
310 # Accepts arbitrary extra emacs/elisp functions to modify the message
311 # before sending, which is useful to doing things like attaching files
312 # to the message and encrypting/signing.
313 emacs_deliver_message ()
314 {
315     local subject="$1"
316     local body="$2"
317     shift 2
318     # before we can send a message, we have to prepare the FCC maildir
319     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
320     # eval'ing smtp-dummy --background will set smtp_dummy_pid
321     smtp_dummy_pid=
322     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
323     test -n "$smtp_dummy_pid" || return 1
324
325     test_emacs \
326         "(let ((message-send-mail-function 'message-smtpmail-send-it)
327                (mail-host-address \"example.com\")
328                (smtpmail-smtp-server \"localhost\")
329                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
330            (notmuch-mua-mail)
331            (message-goto-to)
332            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
333            (message-goto-subject)
334            (insert \"${subject}\")
335            (message-goto-body)
336            (insert \"${body}\")
337            $@
338            (notmuch-mua-send-and-exit))"
339
340     # In case message was sent properly, client waits for confirmation
341     # before exiting and resuming control here; therefore making sure
342     # that server exits by sending (KILL) signal to it is safe.
343     kill -9 $smtp_dummy_pid
344     notmuch new >/dev/null
345 }
346
347 # Pretend to deliver a message with emacs. Really save it to a file
348 # and add it to the database
349 #
350 # Uses emacs to generate and deliver a message to the mail store.
351 # Accepts arbitrary extra emacs/elisp functions to modify the message
352 # before sending, which is useful to doing things like attaching files
353 # to the message and encrypting/signing.
354 #
355 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
356 # at the head of the argument list, they are sent directly to "notmuch
357 # new" after message delivery
358 emacs_fcc_message ()
359 {
360     local nmn_args=''
361     while [[ "$1" =~ ^-- ]]; do
362         nmn_args="$nmn_args $1"
363         shift
364     done
365     local subject="$1"
366     local body="$2"
367     shift 2
368     # before we can send a message, we have to prepare the FCC maildir
369     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
370
371     test_emacs \
372         "(let ((message-send-mail-function (lambda () t))
373                (mail-host-address \"example.com\"))
374            (notmuch-mua-mail)
375            (message-goto-to)
376            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
377            (message-goto-subject)
378            (insert \"${subject}\")
379            (message-goto-body)
380            (insert \"${body}\")
381            $@
382            (notmuch-mua-send-and-exit))" || return 1
383     notmuch new $nmn_args >/dev/null
384 }
385
386 # Add an existing, fixed corpus of email to the database.
387 #
388 # $1 is the corpus dir under corpora to add, using "default" if unset.
389 #
390 # The default corpus is based on about 50 messages from early in the
391 # history of the notmuch mailing list, which allows for reliably
392 # testing commands that need to operate on a not-totally-trivial
393 # number of messages.
394 add_email_corpus ()
395 {
396     corpus=${1:-default}
397
398     rm -rf ${MAIL_DIR}
399     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
400     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
401 }
402
403 test_begin_subtest ()
404 {
405     if [ -n "$inside_subtest" ]; then
406         exec 1>&6 2>&7          # Restore stdout and stderr
407         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
408     fi
409     test_subtest_name="$1"
410     test_reset_state_
411     # Redirect test output to the previously prepared file descriptors
412     # 3 and 4 (see below)
413     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
414     exec >&3 2>&4
415     inside_subtest=t
416 }
417
418 # Pass test if two arguments match
419 #
420 # Note: Unlike all other test_expect_* functions, this function does
421 # not accept a test name. Instead, the caller should call
422 # test_begin_subtest before calling this function in order to set the
423 # name.
424 test_expect_equal ()
425 {
426         exec 1>&6 2>&7          # Restore stdout and stderr
427         if [ -z "$inside_subtest" ]; then
428                 error "bug in the test script: test_expect_equal without test_begin_subtest"
429         fi
430         inside_subtest=
431         test "$#" = 2 ||
432         error "bug in the test script: not 2 parameters to test_expect_equal"
433
434         output="$1"
435         expected="$2"
436         if ! test_skip "$test_subtest_name"
437         then
438                 if [ "$output" = "$expected" ]; then
439                         test_ok_
440                 else
441                         testname=$this_test.$test_count
442                         echo "$expected" > $testname.expected
443                         echo "$output" > $testname.output
444                         test_failure_ "$(diff -u $testname.expected $testname.output)"
445                 fi
446     fi
447 }
448
449 # Like test_expect_equal, but takes two filenames.
450 test_expect_equal_file ()
451 {
452         exec 1>&6 2>&7          # Restore stdout and stderr
453         if [ -z "$inside_subtest" ]; then
454                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
455         fi
456         inside_subtest=
457         test "$#" = 2 ||
458         error "bug in the test script: not 2 parameters to test_expect_equal_file"
459
460         file1="$1"
461         file2="$2"
462         if ! test_skip "$test_subtest_name"
463         then
464                 if diff -q "$file1" "$file2" >/dev/null ; then
465                         test_ok_
466                 else
467                         testname=$this_test.$test_count
468                         basename1=`basename "$file1"`
469                         basename2=`basename "$file2"`
470                         cp "$file1" "$testname.$basename1"
471                         cp "$file2" "$testname.$basename2"
472                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
473                 fi
474     fi
475 }
476
477 # Like test_expect_equal, but arguments are JSON expressions to be
478 # canonicalized before diff'ing.  If an argument cannot be parsed, it
479 # is used unchanged so that there's something to diff against.
480 test_expect_equal_json () {
481     # The test suite forces LC_ALL=C, but this causes Python 3 to
482     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
483     # override Python's stdio encoding defaults.
484     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
485     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
486         || echo "$1")
487     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
488         || echo "$2")
489     shift 2
490     test_expect_equal "$output" "$expected" "$@"
491 }
492
493 # Sort the top-level list of JSON data from stdin.
494 test_sort_json () {
495     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
496         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
497 }
498
499 test_emacs_expect_t () {
500         test "$#" = 1 ||
501         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
502         if [ -z "$inside_subtest" ]; then
503                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
504         fi
505
506         # Run the test.
507         if ! test_skip "$test_subtest_name"
508         then
509                 test_emacs "(notmuch-test-run $1)" >/dev/null
510
511                 # Restore state after the test.
512                 exec 1>&6 2>&7          # Restore stdout and stderr
513                 inside_subtest=
514
515                 # Report success/failure.
516                 result=$(cat OUTPUT)
517                 if [ "$result" = t ]
518                 then
519                         test_ok_
520                 else
521                         test_failure_ "${result}"
522                 fi
523         else
524                 # Restore state after the (non) test.
525                 exec 1>&6 2>&7          # Restore stdout and stderr
526                 inside_subtest=
527         fi
528 }
529
530 NOTMUCH_NEW ()
531 {
532     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
533 }
534
535 NOTMUCH_DUMP_TAGS ()
536 {
537     # this relies on the default format being batch-tag, otherwise some tests will break
538     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
539 }
540
541 notmuch_drop_mail_headers ()
542 {
543     $NOTMUCH_PYTHON -c '
544 import email, sys
545 msg = email.message_from_file(sys.stdin)
546 for hdr in sys.argv[1:]: del msg[hdr]
547 print(msg.as_string(False))
548 ' "$@"
549 }
550
551 notmuch_search_sanitize ()
552 {
553     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
554 }
555
556 notmuch_search_files_sanitize ()
557 {
558     notmuch_dir_sanitize
559 }
560
561 notmuch_dir_sanitize ()
562 {
563     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
564 }
565
566 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
567 notmuch_show_sanitize ()
568 {
569     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
570 }
571 notmuch_show_sanitize_all ()
572 {
573     sed \
574         -e 's| filename:.*| filename:XXXXX|' \
575         -e 's| id:[^ ]* | id:XXXXX |' | \
576         notmuch_date_sanitize
577 }
578
579 notmuch_json_show_sanitize ()
580 {
581     sed \
582         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
583         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
584         -e 's|"filename": "signature.asc",||g' \
585         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
586         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
587         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
588 }
589
590 notmuch_emacs_error_sanitize ()
591 {
592     local command=$1
593     shift
594     for file in "$@"; do
595         echo "=== $file ==="
596         cat "$file"
597     done | sed  \
598         -e 's/^\[.*\]$/[XXX]/' \
599         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
600 }
601
602 notmuch_date_sanitize ()
603 {
604     sed \
605         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
606 }
607
608 notmuch_uuid_sanitize ()
609 {
610     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
611 }
612
613 notmuch_built_with_sanitize ()
614 {
615     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
616 }
617
618 notmuch_config_sanitize ()
619 {
620     notmuch_dir_sanitize | notmuch_built_with_sanitize
621 }
622
623 notmuch_show_part ()
624 {
625     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
626 }
627
628 # End of notmuch helper functions
629
630 # Use test_set_prereq to tell that a particular prerequisite is available.
631 #
632 # The prerequisite can later be checked for by using test_have_prereq.
633 #
634 # The single parameter is the prerequisite tag (a simple word, in all
635 # capital letters by convention).
636
637 test_set_prereq () {
638         satisfied="$satisfied$1 "
639 }
640 satisfied=" "
641
642 test_have_prereq () {
643         case $satisfied in
644         *" $1 "*)
645                 : yes, have it ;;
646         *)
647                 ! : nope ;;
648         esac
649 }
650
651 declare -A test_missing_external_prereq_
652 declare -A test_subtest_missing_external_prereq_
653
654 # declare prerequisite for the given external binary
655 test_declare_external_prereq () {
656         binary="$1"
657         test "$#" = 2 && name=$2 || name="$binary(1)"
658
659         if ! hash $binary 2>/dev/null; then
660                 test_missing_external_prereq_["${binary}"]=t
661                 eval "
662 $binary () {
663         test_subtest_missing_external_prereq_[\"${name}\"]=t
664         false
665 }"
666         fi
667 }
668
669 # Explicitly require external prerequisite.  Useful when binary is
670 # called indirectly (e.g. from emacs).
671 # Returns success if dependency is available, failure otherwise.
672 test_require_external_prereq () {
673         binary="$1"
674         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
675                 # dependency is missing, call the replacement function to note it
676                 eval "$binary"
677         else
678                 true
679         fi
680 }
681
682 # You are not expected to call test_ok_ and test_failure_ directly, use
683 # the text_expect_* functions instead.
684
685 test_ok_ () {
686         if test "$test_subtest_known_broken_" = "t"; then
687                 test_known_broken_ok_
688                 return
689         fi
690         test_success=$(($test_success + 1))
691         if test -n "$NOTMUCH_TEST_QUIET"; then
692                 return 0
693         fi
694         say_color pass "%-6s" "PASS"
695         echo " $test_subtest_name"
696 }
697
698 test_failure_ () {
699         print_test_description
700         if test "$test_subtest_known_broken_" = "t"; then
701                 test_known_broken_failure_ "$@"
702                 return
703         fi
704         test_failure=$(($test_failure + 1))
705         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
706         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
707         return 1
708 }
709
710 test_failure_message_ () {
711         say_color error "%-6s" "$1"
712         echo " $2"
713         shift 2
714         if [ "$#" != "0" ]; then
715                 echo "$@" | sed -e 's/^/        /'
716         fi
717         if test "$verbose" != "t"; then cat test.output; fi
718 }
719
720 test_known_broken_ok_ () {
721         test_reset_state_
722         test_fixed=$(($test_fixed+1))
723         say_color pass "%-6s" "FIXED"
724         echo " $test_subtest_name"
725 }
726
727 test_known_broken_failure_ () {
728         test_reset_state_
729         test_broken=$(($test_broken+1))
730         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
731                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
732         else
733                 test_failure_message_ "BROKEN" "$test_subtest_name"
734         fi
735         return 1
736 }
737
738 test_debug () {
739         test "$debug" = "" || eval "$1"
740 }
741
742 test_run_ () {
743         test_cleanup=:
744         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
745         eval >&3 2>&4 "$1"
746         eval_ret=$?
747         eval >&3 2>&4 "$test_cleanup"
748         return 0
749 }
750
751 test_skip () {
752         test_count=$(($test_count+1))
753         to_skip=
754         for skp in $NOTMUCH_SKIP_TESTS
755         do
756                 case $this_test.$test_count in
757                 $skp)
758                         to_skip=t
759                         break
760                 esac
761                 case $this_test_bare.$test_count in
762                 $skp)
763                         to_skip=t
764                         break
765                 esac
766         done
767         case "$to_skip" in
768         t)
769                 test_report_skip_ "$@"
770                 ;;
771         *)
772                 test_check_missing_external_prereqs_ "$@"
773                 ;;
774         esac
775 }
776
777 test_check_missing_external_prereqs_ () {
778         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
779                 say_color skip >&1 "missing prerequisites: "
780                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
781                 test_report_skip_ "$@"
782         else
783                 false
784         fi
785 }
786
787 test_report_skip_ () {
788         test_reset_state_
789         say_color skip >&3 "skipping test:"
790         echo " $@" >&3
791         say_color skip "%-6s" "SKIP"
792         echo " $1"
793 }
794
795 test_subtest_known_broken () {
796         test_subtest_known_broken_=t
797 }
798
799 test_expect_success () {
800         exec 1>&6 2>&7          # Restore stdout and stderr
801         if [ -z "$inside_subtest" ]; then
802                 error "bug in the test script: test_expect_success without test_begin_subtest"
803         fi
804         inside_subtest=
805         test "$#" = 1 ||
806         error "bug in the test script: not 1 parameters to test_expect_success"
807
808         if ! test_skip "$test_subtest_name"
809         then
810                 test_run_ "$1"
811                 run_ret="$?"
812                 # test_run_ may update missing external prerequisites
813                 test_check_missing_external_prereqs_ "$@" ||
814                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
815                 then
816                         test_ok_
817                 else
818                         test_failure_ "$1"
819                 fi
820         fi
821 }
822
823 test_expect_code () {
824         exec 1>&6 2>&7          # Restore stdout and stderr
825         if [ -z "$inside_subtest" ]; then
826                 error "bug in the test script: test_expect_code without test_begin_subtest"
827         fi
828         inside_subtest=
829         test "$#" = 2 ||
830         error "bug in the test script: not 2 parameters to test_expect_code"
831
832         if ! test_skip "$test_subtest_name"
833         then
834                 test_run_ "$2"
835                 run_ret="$?"
836                 # test_run_ may update missing external prerequisites,
837                 test_check_missing_external_prereqs_ "$@" ||
838                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
839                 then
840                         test_ok_
841                 else
842                         test_failure_ "exit code $eval_ret, expected $1" "$2"
843                 fi
844         fi
845 }
846
847 # This is not among top-level (test_expect_success)
848 # but is a prefix that can be used in the test script, like:
849 #
850 #       test_expect_success 'complain and die' '
851 #           do something &&
852 #           do something else &&
853 #           test_must_fail git checkout ../outerspace
854 #       '
855 #
856 # Writing this as "! git checkout ../outerspace" is wrong, because
857 # the failure could be due to a segv.  We want a controlled failure.
858
859 test_must_fail () {
860         "$@"
861         test $? -gt 0 -a $? -le 129 -o $? -gt 192
862 }
863
864 # test_cmp is a helper function to compare actual and expected output.
865 # You can use it like:
866 #
867 #       test_expect_success 'foo works' '
868 #               echo expected >expected &&
869 #               foo >actual &&
870 #               test_cmp expected actual
871 #       '
872 #
873 # This could be written as either "cmp" or "diff -u", but:
874 # - cmp's output is not nearly as easy to read as diff -u
875 # - not all diff versions understand "-u"
876
877 test_cmp() {
878         $GIT_TEST_CMP "$@"
879 }
880
881 # This function can be used to schedule some commands to be run
882 # unconditionally at the end of the test to restore sanity:
883 #
884 #       test_expect_success 'test core.capslock' '
885 #               git config core.capslock true &&
886 #               test_when_finished "git config --unset core.capslock" &&
887 #               hello world
888 #       '
889 #
890 # That would be roughly equivalent to
891 #
892 #       test_expect_success 'test core.capslock' '
893 #               git config core.capslock true &&
894 #               hello world
895 #               git config --unset core.capslock
896 #       '
897 #
898 # except that the greeting and config --unset must both succeed for
899 # the test to pass.
900
901 test_when_finished () {
902         test_cleanup="{ $*
903                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
904 }
905
906 test_done () {
907         GIT_EXIT_OK=t
908         test_results_dir="$TEST_DIRECTORY/test-results"
909         mkdir -p "$test_results_dir"
910         test_results_path="$test_results_dir/$this_test"
911
912         echo "total $test_count" >> $test_results_path
913         echo "success $test_success" >> $test_results_path
914         echo "fixed $test_fixed" >> $test_results_path
915         echo "broken $test_broken" >> $test_results_path
916         echo "failed $test_failure" >> $test_results_path
917         echo "" >> $test_results_path
918
919         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
920
921         if [ "$test_failure" = "0" ]; then
922             if [ "$test_broken" = "0" ]; then
923                 rm -rf "$remove_tmp"
924             fi
925             exit 0
926         else
927             exit 1
928         fi
929 }
930
931 emacs_generate_script () {
932         # Construct a little test script here for the benefit of the user,
933         # (who can easily run "run_emacs" to get the same emacs environment
934         # for investigating any failures).
935         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
936 #!/bin/sh
937 export PATH=$PATH
938 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
939
940 # Here's what we are using here:
941 #
942 # --quick              Use minimal customization. This implies --no-init-file,
943 #                      --no-site-file and (emacs 24) --no-site-lisp
944 #
945 # --directory           Ensure that the local elisp sources are found
946 #
947 # --load                Force loading of notmuch.el and test-lib.el
948
949 exec ${TEST_EMACS} --quick \
950         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
951         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
952         "\$@"
953 EOF
954         chmod a+x "$TMP_DIRECTORY/run_emacs"
955 }
956
957 test_emacs () {
958         # test dependencies beforehand to avoid the waiting loop below
959         missing_dependencies=
960         test_require_external_prereq dtach || missing_dependencies=1
961         test_require_external_prereq emacs || missing_dependencies=1
962         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
963         test -z "$missing_dependencies" || return
964
965         if [ -z "$EMACS_SERVER" ]; then
966                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
967                 if [ -f "$emacs_tests" ]; then
968                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
969                 else
970                         load_emacs_tests=
971                 fi
972                 server_name="notmuch-test-suite-$$"
973                 # start a detached session with an emacs server
974                 # user's TERM (or 'vt100' in case user's TERM is known dumb
975                 # or unknown) is given to dtach which assumes a minimally
976                 # VT100-compatible terminal -- and emacs inherits that
977                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
978                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
979                                 --no-window-system \
980                                 $load_emacs_tests \
981                                 --eval '(setq server-name \"$server_name\")' \
982                                 --eval '(server-start)' \
983                                 --eval '(orphan-watchdog $$)'" || return
984                 EMACS_SERVER="$server_name"
985                 # wait until the emacs server is up
986                 until test_emacs '()' >/dev/null 2>/dev/null; do
987                         sleep 1
988                 done
989         fi
990
991         # Clear test-output output file.  Most Emacs tests end with a
992         # call to (test-output).  If the test code fails with an
993         # exception before this call, the output file won't get
994         # updated.  Since we don't want to compare against an output
995         # file from another test, so start out with an empty file.
996         rm -f OUTPUT
997         touch OUTPUT
998
999         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1000 }
1001
1002 test_python() {
1003     # Note: if there is need to print debug information from python program,
1004     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1005     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1006         $NOTMUCH_PYTHON -B - > OUTPUT
1007 }
1008
1009 test_ruby() {
1010     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1011 }
1012
1013 test_C () {
1014     exec_file="test${test_count}"
1015     test_file="${exec_file}.c"
1016     cat > ${test_file}
1017     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1018     echo "== stdout ==" > OUTPUT.stdout
1019     echo "== stderr ==" > OUTPUT.stderr
1020     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1021     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1022 }
1023
1024
1025 # Creates a script that counts how much time it is executed and calls
1026 # notmuch.  $notmuch_counter_command is set to the path to the
1027 # generated script.  Use notmuch_counter_value() function to get the
1028 # current counter value.
1029 notmuch_counter_reset () {
1030         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1031         if [ ! -x "$notmuch_counter_command" ]; then
1032                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1033                 cat >"$notmuch_counter_command" <<EOF || return
1034 #!/bin/sh
1035
1036 read count < "$notmuch_counter_state_path"
1037 echo \$((count + 1)) > "$notmuch_counter_state_path"
1038
1039 exec notmuch "\$@"
1040 EOF
1041                 chmod +x "$notmuch_counter_command" || return
1042         fi
1043
1044         echo 0 > "$notmuch_counter_state_path"
1045 }
1046
1047 # Returns the current notmuch counter value.
1048 notmuch_counter_value () {
1049         if [ -r "$notmuch_counter_state_path" ]; then
1050                 read count < "$notmuch_counter_state_path"
1051         else
1052                 count=0
1053         fi
1054         echo $count
1055 }
1056
1057 test_reset_state_ () {
1058         test -z "$test_init_done_" && test_init_
1059
1060         test_subtest_known_broken_=
1061         test_subtest_missing_external_prereq_=()
1062 }
1063
1064 # called once before the first subtest
1065 test_init_ () {
1066         test_init_done_=t
1067
1068         # skip all tests if there were external prerequisites missing during init
1069         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1070 }
1071
1072
1073 # Where to run the tests
1074 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1075
1076 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1077
1078 emacs_generate_script
1079
1080
1081 # Use -P to resolve symlinks in our working directory so that the cwd
1082 # in subprocesses like git equals our $PWD (for pathname comparisons).
1083 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1084
1085 if test "$verbose" = "t"
1086 then
1087         exec 4>&2 3>&1
1088 else
1089         exec 4>test.output 3>&4
1090 fi
1091
1092 for skp in $NOTMUCH_SKIP_TESTS
1093 do
1094         to_skip=
1095         for skp in $NOTMUCH_SKIP_TESTS
1096         do
1097                 case "$this_test" in
1098                 $skp)
1099                         to_skip=t
1100                         break
1101                 esac
1102                 case "$this_test_bare" in
1103                 $skp)
1104                         to_skip=t
1105                         break
1106                 esac
1107         done
1108         case "$to_skip" in
1109         t)
1110                 say_color skip >&3 "skipping test $this_test altogether"
1111                 say_color skip "skip all tests in $this_test"
1112                 test_done
1113         esac
1114 done
1115
1116 # Provide an implementation of the 'yes' utility
1117 yes () {
1118         if test $# = 0
1119         then
1120                 y=y
1121         else
1122                 y="$*"
1123         fi
1124
1125         while echo "$y"
1126         do
1127                 :
1128         done
1129 }
1130
1131 # Fix some commands on Windows
1132 case $(uname -s) in
1133 *MINGW*)
1134         # Windows has its own (incompatible) sort and find
1135         sort () {
1136                 /usr/bin/sort "$@"
1137         }
1138         find () {
1139                 /usr/bin/find "$@"
1140         }
1141         sum () {
1142                 md5sum "$@"
1143         }
1144         # git sees Windows-style pwd
1145         pwd () {
1146                 builtin pwd -W
1147         }
1148         # no POSIX permissions
1149         # backslashes in pathspec are converted to '/'
1150         # exec does not inherit the PID
1151         ;;
1152 *)
1153         test_set_prereq POSIXPERM
1154         test_set_prereq BSLASHPSPEC
1155         test_set_prereq EXECKEEPSPID
1156         ;;
1157 esac
1158
1159 test -z "$NO_PERL" && test_set_prereq PERL
1160 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1161
1162 # test whether the filesystem supports symbolic links
1163 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1164 rm -f y
1165
1166 # convert variable from configure to more convenient form
1167 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1168     glass)
1169         db_ending=glass
1170     ;;
1171     chert)
1172         db_ending=DB
1173     ;;
1174     *)
1175         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1176 esac
1177 # declare prerequisites for external binaries used in tests
1178 test_declare_external_prereq dtach
1179 test_declare_external_prereq emacs
1180 test_declare_external_prereq ${TEST_EMACSCLIENT}
1181 test_declare_external_prereq ${TEST_GDB}
1182 test_declare_external_prereq gpg
1183 test_declare_external_prereq openssl
1184 test_declare_external_prereq gpgsm
1185 test_declare_external_prereq ${NOTMUCH_PYTHON}